#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cfile.h"
#include "conflib.h"
#include "defines.h"

char * rootDir=NULL;
cl_list_t *source=NULL;
cl_list_t *blackList=NULL;
char *mopHost=NULL;
char *mopPass=NULL;
char *mopEmail=NULL;
char *mopMachine=NULL;
int mopPort=0;
char *pager=NULL;
char *editor=NULL;
char *tmp;
char *var;
char *fetcher;
char *mopBrowser="links", *mopWWW="http://sokrates.mimuw.edu.pl/~pawelk/mop/";


void readConfig(char *fname, int obligatory)
{
	cl_var_t conf_vars[]={
		{"root_dir",	NULL,	CL_DIRNAME,	&rootDir,0,NULL},
		{"source",	"\n",	CL_LIST,	&source ,0,NULL},
		{"fetcher",	NULL,	CL_STRING,	&fetcher,0,NULL},
		{"black_list",  ", ;:",	CL_LIST,	&blackList,0,NULL},
		{"mop_server",	NULL,	CL_STRING,	&mopHost,0,NULL},
		{"mop_port",	NULL,	CL_NUM,		&mopPort,0,NULL},
		{"mop_email",	NULL,	CL_STRING,	&mopEmail ,0,NULL},
		{"mop_pass",	NULL,	CL_STRING,	&mopPass,0,NULL},
		{"mop_machine",	NULL,	CL_STRING,	&mopMachine,0,NULL},
		{"mop_browser", NULL,   CL_STRING, 	&mopBrowser,0,NULL},
		{"mop_www",	NULL,	CL_STRING,	&mopWWW,0,NULL},
		{"pager",	"PAGER",CL_STRING, &pager,CL_PREENV,NULL},
		{"editor",	"EDITOR",CL_STRING, &editor,CL_PREENV,NULL},
		{"tmp_dir", "WUCH_TEMP",CL_STRING,&tmp, CL_POSTENV,NULL},
		{"var_dir", "WUCH_VAR",CL_STRING,&var, CL_POSTENV,NULL},
		{NULL,NULL,0,NULL,0}
	};
	int res;

	res=cl_getconf(fname,conf_vars);
	if(res){
		fprintf(stderr,_("Can't open configuration file %s\n"),
					fname);
		if(obligatory)
			exit(1);
		else
			return;
	}
	if(!mopHost)
		mopHost=strdup("localhost");
	if(!mopPort)
		mopPort=16235;
	fprintf(stderr,"%s vardir: %s\n", __FUNCTION__ , getVar());
	fprintf(stderr,"%s tmpdir: %s\n", __FUNCTION__ , getTmp());
}

void addConfig(char *txt)
{
	char buf[1000];
	FILE *f;
	sprintf(buf,"%s/etc/wuch.conf",getenv("HOME"));
	f = fopen(buf, "a");
	if(f == NULL){
		sprintf(buf,"%s/.wuch.conf",getenv("HOME"));
		f = fopen(buf, "a");
		if(f==NULL){
			fprintf(stderr,"nie mozna otworzyc pliku z konfiguracja do zapisu !\n");
			exit(1);
		}
		
			
	}
	fprintf(f,"\n\n#Aded automaticaly by wuch\n");
	fprintf(f,"%s\n",txt);
	fclose(f);
}

char * getRootDir()
{
	return rootDir;
}

void setRootDir(char *dir)
{
	rootDir=strdup(dir);
}

char * getSource(int no)
{
	int i=no;
	cl_list_t *ptr=source;

	while(i && ptr){
		ptr=ptr->next;
		i--;
	}
	if(ptr)
		return ptr->inhalt;
	else
		return NULL;
}

void addSource(char *src)
{
	cl_list_t *ptr;
	if(src == NULL || src[0] == 0)
		return;
	if(source ==NULL){
		source = (cl_list_t*) malloc(sizeof(cl_list_t));
		source->next=NULL;
		source->inhalt=strdup(src);
	}else{
		ptr=source;
		while(ptr->next){
			ptr = ptr->next;
		}
		ptr->next = (cl_list_t*) malloc(sizeof(cl_list_t));
		ptr = ptr->next;
		ptr->next = NULL;
		ptr->inhalt = strdup(src);
	}
}






int isOnBlackList(char *name)
{
	cl_list_t *ptr = blackList;
	while(ptr){
		if(ptr->inhalt && strcmp(ptr->inhalt, name) == 0)
			return 1;
		ptr = ptr->next;
	}
	return 0;
}

void showBlackList()
{
	cl_list_t *ptr = blackList;
	while(ptr){
		printf("pakiet: '%s'\n",ptr->inhalt);
		ptr = ptr->next;
	}
}


char *getMopHost()
{
	return mopHost;
}

int getMopPort()
{
	return mopPort;
}

char *getMopEmail()
{
	return mopEmail;
}

void setMopEmail(char *email)
{
	mopEmail=strdup(email);
}

char *getMopMachine()
{
	return mopMachine;
}

char *getPager()
{
	return pager;
}


char *getEditor()
{
	return editor;
}

char *getMopPass()
{
	return mopPass;
}

void setMopPass(char *pass)
{
	mopPass=strdup(pass);
}

char * getMopBrowser()
{
	return mopBrowser;
}

char *getMopWWW()
{ 
	return mopWWW;
}

char * getVar()
{
	if(var && var[0])
		return var;
	else
		return "/var/cache/wuch";
}

char * getTmp()
{
	if(tmp && tmp[0])
		return tmp;
	else
		return "/tmp";
}

char * getFetcherCommand(char *url, char *destDir)
{
	static char ret[1000];
	char *r,*w, *t;
	if(fetcher == NULL)
		return NULL;
	r = fetcher;
	w = ret;
	while(*r){
		switch(*r){
			case '%': 
				t = NULL;
				switch(*(r+1)){
					case 'U': t = url;  break;
					case 'D': t = destDir; break;
					default: *w = *r; w++;r++; break;
				}
				if(t){
					r++;
					r++;
					while(*t){
						*w=*t;
						w++;t++;
					}
				}
				break;
			default: *w = *r; w++; r++;break;
		}
	}
	return ret;
}

#ifdef TESTfetcher

main()
{
	fetcher="wget %U %D  %%uf ple";
	printf("%s\n",getFetcherCommand("ftp://paw/ple","kle"));
}
#endif
